<template>
	<v-container>
		<v-snackbar v-model="snack" :timeout="timeout" top color="blue">Puntaje actualizado</v-snackbar>
		<p class="display-1 text-center">Gestión de puntajes</p>
		<!-- Género -->
		<p class="headline text-center">Género</p>
		<v-row justify="space-around">
			<v-col cols="12" sm="2">
				<v-text-field label="Hombre" v-model="gender.male" outlined type="number" min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field label="Mujer" v-model="gender.female" outlined type="number" min="0" />
			</v-col>
			<v-col cols="12" sm="4">
				<v-btn :loading="loading1" color="green" outlined block @click="updateScoreGender">
					Actualizar
					<template v-slot:loader>
						<span>Guardando...</span>
					</template>
				</v-btn>
			</v-col>
		</v-row>
		<!-- ingresos -->
		<p class="headline text-center">Ingresos</p>
		<v-row justify="space-around">
			<v-col cols="12" sm="2">
				<v-text-field label="$0 - $5000" v-model="economicIncomes.range1" outlined type="number" min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field
					label="$5001 - $10000"
					v-model="economicIncomes.range2"
					outlined
					type="number"
					min="0"
				/>
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field
					label="$10001 - $90000"
					v-model="economicIncomes.range3"
					outlined
					type="number"
					min="0"
				/>
			</v-col>
			<v-col cols="4">
				<v-btn :loading="loading2" color="green" outlined block @click="updateScoreEconomicIncomes">
					Actualizar
					<template v-slot:loader>
						<span>Guardando...</span>
					</template>
				</v-btn>
			</v-col>
		</v-row>
		<!-- Ciudades -->
		<p class="headline text-center">Ciudades</p>
		<v-row justify="space-around">
			<v-col cols="12" sm="2">
				<v-text-field label="Zacatecas" v-model="cities.zacatecas" outlined type="number" min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field
					label="Guadalupe"
					v-model="cities.guadalupe"
					outlined
					type="number"
					min="0"
				/>
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field
					label="Otros"
					v-model="cities.others"
					outlined
					type="number"
					min="0"
				/>
			</v-col>
			<v-col cols="4">
				<v-btn :loading="loading6" color="green" outlined block @click="updateScoreCities">
					Actualizar
					<template v-slot:loader>
						<span>Guardando...</span>
					</template>
				</v-btn>
			</v-col>
		</v-row>
		<!-- Tipo de solicitud -->
		<p class="headline text-center">Tipo de solicitud</p>
		<v-row justify="space-around">
			<v-col cols="12" sm="2">
				<v-text-field
					label="Nuevo ingreso"
					v-model="typeScholarship.new"
					outlined
					type="number"
					min="0"
				/>
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field label="Renovación" v-model="typeScholarship.ren" outlined type="number" min="0" />
			</v-col>
			<v-col cols="4">
				<v-btn
					:loading="loading3"
					color="green"
					outlined
					block
					@click="updateScoreTypeScholarship"
				>Actualizar</v-btn>
			</v-col>
		</v-row>
		<!-- Periodo -->
		<p class="headline text-center">Periodo</p>
		<v-row justify="space-around">
			<v-col cols="12" sm="2">
				<v-text-field 
					label="1 - 5"
					v-model="period.low"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field 
					label="6 - 15"
					v-model="period.high"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="4">
				<v-btn
					:loading="loading4"
					color="green"
					outlined
					block
					@click="updateScorePeriod"
				>Actualizar</v-btn>
			</v-col>
		</v-row>
		<!-- Promedio -->
		<p class="headline text-center">Promedio escolar</p>
		<v-row justify="space-around">
			<v-col cols="12" sm="2">
				<v-text-field 
					label="7.5 - 7.99"
					v-model="schoolGrade.one"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field 
					label="8.0 - 8.49"
					v-model="schoolGrade.two"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field 
					label="8.5 - 8.99"
					v-model="schoolGrade.three"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field 
					label="9.0 - 9.49"
					v-model="schoolGrade.four"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-text-field 
					label="9.5 - 10.0"
					v-model="schoolGrade.five"
					outlined
					type="number"
					min="0" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-btn
					:loading="loading5"
					color="green"
					outlined
					block
					@click="updateScoreSchoolGrade"
				>Actualizar</v-btn>
			</v-col>
		</v-row>
		<!-- Formulario para agregar institución -->
		<v-row justify="center" justify-sm="end">
			<v-col cols="12" sm="5">
				<v-text-field v-model="institute" outlined label="Ingrese nueva institución" />
			</v-col>
			<v-col cols="12" sm="1">
				<v-text-field v-model="value" outlined type="number" min="0" label="Valor" />
			</v-col>
			<v-col cols="12" sm="2">
				<v-btn outlined color="green" block @click="addInstitute">Agregar</v-btn>
			</v-col>
		</v-row>
		<!-- Tabla de institutos -->
		<v-row>
			<InstitutesTable />
		</v-row>
		<Navigation />
	</v-container>
</template>

<script>
import Navigation from "@/components/Navigation";
import InstitutesTable from "@/components/admin/InstitutesTable";
import gql from "graphql-tag";
import { mapMutations } from "vuex";
import EventBus from "../../bus";

export default {
	name: "Institutes",
	components: {
		Navigation,
		InstitutesTable
	},
	data: () => ({
		gender: {
			male: 0,
			female: 0
		},
		economicIncomes: {
			range1: 0,
			range2: 0,
			range3: 0
		},
		typeScholarship: {
			new: 0,
			ren: 0
		},
		period: {
			low: 0,
			high: 0
		},
		schoolGrade: {
			one: 0,
			two: 0,
			three: 0,
			four: 0,
			five: 0
		},
		cities: {
			zacatecas: 0,
			guadalupe: 0,
			others: 0
		},
		institute: "",
		value: 0,
		snack: false,
		timeout: 2000,
		loading1: false,
		loading2: false,
		loading3: false,
		loading4: false,
		loading5: false,
		loading6: false
	}),
	methods: {
		...mapMutations(["saveUserData"]),
		// Agrega nueva institución
		async addInstitute() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($name: String!, $value: Int!) {
							addInstitute(name: $name, value: $value)
						}
					`,
					variables: {
						name: this.institute,
						value: parseInt(this.value, 10)
					}
				});
				EventBus.$emit("sendInstitute");
				this.value = 0;
				this.institute = "";
			} catch (error) {}
		},
		// obtiene los puntajes de genero
		async getScoreGender() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($param: String!) {
							getPoints(param: $param) {
								key
								value
							}
						}
					`,
					variables: {
						param: "gender"
					}
				});
				this.gender.male = data.getPoints[0].value;
				this.gender.female = data.getPoints[1].value;
				this.getScoreEconomicIncomes();
				this.getScoreTypeScholarship();
				this.getScoreCities();
				this.getScorePeriod();
				this.getScoreSchoolGrade();
			} catch (error) {}
		},
		// obtiene los puntajes de las ciudades
		async getScoreCities(){
			try {

				const { data } = await this.$apollo.query({
					query: gql`
						query {
							getValueCities{
								key
								value
							}
						}
					`
				});

				this.cities.others = data.getValueCities[0].value;
				this.cities.guadalupe = data.getValueCities[1].value;
				this.cities.zacatecas = data.getValueCities[2].value;
			} catch (error) {}
		},
		// obtiene los puntajes de ingresos
		async getScoreEconomicIncomes() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($param: String!) {
							getPoints(param: $param) {
								key
								value
							}
						}
					`,
					variables: {
						param: "economicIncomes"
					}
				});
				this.economicIncomes.range1 = data.getPoints[0].value;
				this.economicIncomes.range2 = data.getPoints[1].value;
				this.economicIncomes.range3 = data.getPoints[2].value;
			} catch (error) {}
		},
		// obtiene los puntajes del tipo de beca
		async getScoreTypeScholarship() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($param: String!) {
							getPoints(param: $param) {
								key
								value
							}
						}
					`,
					variables: {
						param: "status"
					}
				});
				this.typeScholarship.ren = data.getPoints[0].value;
				this.typeScholarship.new = data.getPoints[1].value;
			} catch (error) {}
		},
		// obtiene los puntajes del periodo
		async getScorePeriod(){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($param: String!){
							getPoints(param: $param){
								key
								value
							}
						}
					`,
					variables: {
						param: "period"
					}
				});
				this.period.low = data.getPoints[0].value;
				this.period.high = data.getPoints[1].value;
			} catch (error) {}
		},
		// obtiene los puntajes del promedio
		async getScoreSchoolGrade(){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($param: String!){
							getPoints(param: $param){
								key
								value
							}
						}
					`,
					variables: {
						param: "schoolGrades"
					}
				});
				this.schoolGrade.one = data.getPoints[0].value;
				this.schoolGrade.two = data.getPoints[1].value;
				this.schoolGrade.three = data.getPoints[2].value;
				this.schoolGrade.four = data.getPoints[3].value;
				this.schoolGrade.five = data.getPoints[4].value;
			} catch (error) {}
		},
		// actualiza los puntajes de genero
		async updateScoreGender() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "gender",
						key: "Hombre",
						value: parseInt(this.gender.male, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "gender",
						key: "Mujer",
						value: parseInt(this.gender.female, 10)
					}
				});
				this.loading1 = true;
				setTimeout(() => {
					this.loading1 = false;
					this.snack = true;
				}, 2000);
			} catch (error) {}
		},
		// actualiza los puntajes de ingresos
		async updateScoreEconomicIncomes() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "economicIncomes",
						key: "0-5000",
						value: parseInt(this.economicIncomes.range1, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "economicIncomes",
						key: "5001-10000",
						value: parseInt(this.economicIncomes.range2, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "economicIncomes",
						key: "10001-90000",
						value: parseInt(this.economicIncomes.range3, 10)
					}
				});
				this.loading2 = true;
				setTimeout(() => {
					this.loading2 = false;
					this.snack = true;
				}, 2000);
			} catch (error) {}
		},
		// actualiza los puntajes de solicitud
		async updateScoreTypeScholarship() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "status",
						key: "Nuevo ingreso",
						value: parseInt(this.typeScholarship.new, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!) {
							changeValuePoints(
								field: $field
								key: $key
								value: $value
							)
						}
					`,
					variables: {
						field: "status",
						key: "Renovación",
						value: parseInt(this.typeScholarship.ren, 10)
					}
				});
				this.loading3 = true;
				setTimeout(() => {
					this.loading3 = false;
					this.snack = true;
				}, 2000);
			} catch (error) {}
		},
		// actualiza los puntajes del periodo
		async updateScorePeriod(){
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"period",
						key:"1-5",
						value:parseInt(this.period.low, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"period",
						key:"6-15",
						value:parseInt(this.period.high, 10)
					}
				});

				this.loading4 = true;
				setTimeout(() => {
					this.loading4 = false;
					this.snack = true;
				}, 2000);
			} catch (error) {}
		},
		// actualiza los puntajes del promedio
		async updateScoreSchoolGrade() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"schoolGrades",
						key:"7.5-7.99",
						value:parseInt(this.schoolGrade.one, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"schoolGrades",
						key:"8-8.49",
						value:parseInt(this.schoolGrade.two, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"schoolGrades",
						key:"8.5-8.99",
						value:parseInt(this.schoolGrade.three, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"schoolGrades",
						key:"9-9.49",
						value:parseInt(this.schoolGrade.four, 10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($field: String!, $key: String!, $value: Int!){
							changeValuePoints(field: $field, key: $key, value: $value)
						}
					`,
					variables:{
						field:"schoolGrades",
						key:"9.5-10",
						value:parseInt(this.schoolGrade.five, 10)
					}
				});

				this.loading5 = true;
				setTimeout(() => {
					this.loading5 = false;
					this.snack = true;
				}, 2000);
			} catch (error) {}
		},
		// actualiza el puntaje de las ciudades
		async updateScoreCities(){
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($city: String!, $value: Int!){
							changeValueCities(city: $city, value: $value)
						}
					`,
					variables: {
						city: "Zacatecas",
						value: parseInt(this.cities.zacatecas,10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($city: String!, $value: Int!){
							changeValueCities(city: $city, value: $value)
						}
					`,
					variables: {
						city: "Guadalupe",
						value: parseInt(this.cities.guadalupe,10)
					}
				});
				await this.$apollo.mutate({
					mutation: gql`
						mutation($city: String!, $value: Int!){
							changeValueCities(city: $city, value: $value)
						}
					`,
					variables: {
						city: "Others",
						value: parseInt(this.cities.others,10)
					}
				});

				this.loading6 = true;
				setTimeout(() => {
					this.loading6 = false;
					this.snack = true;
				}, 2000);
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.getScoreGender();
	}
};
</script>